/// <reference types="node" />
export declare class ChunkBuffer {
    readonly name: string;
    readonly bytes: number;
    readonly sbuf: StreamBuffer;
    readonly buffer: Buffer;
    ofs: number;
    constructor(name: string, bytes: number, sbuf: StreamBuffer, buffer?: Buffer, ofs?: number);
    writeBoolean(val: Boolean): void;
    writeUint8(val: number): void;
    writeChar(val: number): void;
    writeUint16(val: number): void;
    writeShort(val: number): void;
    writeUint32(val: number): void;
    writeInt(val: number): void;
    writeFloat(val: number): void;
    writeDouble(val: number): void;
    readBoolean(): boolean;
    readUint8(): number;
    readChar(): number;
    readUint16(): number;
    readShort(): number;
    readUint32(): number;
    readInt(): number;
    readFloat(): number;
    readDouble(): number;
}
export declare class StreamBuffer {
    buffers: ChunkBuffer[];
    constructor(u8s?: Uint8Array[]);
    currentWriteChunk(name: string, bytes: number): ChunkBuffer;
    currentReadChunk(name: string, bytes: number): ChunkBuffer;
    prepareRead<T>(name: string, bytes: number, cb: (wb: ChunkBuffer) => T): T;
    prepareWrite<T>(name: string, bytes: number, cb: (wb: ChunkBuffer) => void): StreamBuffer;
    asUint8Array(): Uint8Array;
}
