import { Option } from '../optional';
import { NestedPartial } from '../nested';
import { ChunkBuffer, StreamBuffer } from '../stream-buffer';
export declare type TypeName = 'Boolean' | 'Uint8' | 'Char' | 'Uint16' | 'Short' | 'Uint32' | 'Int' | 'Float' | 'Uint64' | 'Long' | 'Double' | 'FixedArray' | 'FixedCString' | 'Struct' | 'BitStruct';
export declare type FilterFunc<T> = (val: T | undefined) => Option<T>;
export declare type CreateFunc<T> = (...vals: Partial<T>[]) => T;
export declare abstract class Definition<T> {
    abstract readonly type: TypeName;
    abstract readonly bytes: number;
    abstract readonly givenInitial: Option<unknown>;
    abstract coerce(val: unknown): Option<unknown>;
    abstract create(...vals: (undefined | T | NestedPartial<T>)[]): T;
    abstract fromStreamChunk(chunk: ChunkBuffer, name: string): T;
    abstract toStreamChunk(val: T, chunk: ChunkBuffer, name: string): void;
    fromStream(rb: StreamBuffer, name: string): T;
    toStream(val: T, buf: StreamBuffer, name?: string): StreamBuffer;
}
export interface ScalarTypeArg<T> {
    readonly initial?: T;
}
export declare abstract class NamedType<T> extends Definition<T> {
    abstract readonly name: string;
}
