"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Definition = void 0;
const optional_1 = require("../optional");
const base_1 = require("./base");
let Definition = /** @class */ (() => {
    class Definition extends base_1.Definition {
        constructor(arg) {
            super();
            this.type = Definition.type;
            this.bytes = Definition.bytes;
            const val = (arg || {}).initial;
            this.givenInitial = this.coerce(val);
            // this.initial = this.create(val);
        }
        coerce(val) {
            return typeof val === 'boolean' ? optional_1.SomeOption(val) : optional_1.NoneOption;
        }
        create(...vals) {
            return (vals.concat(optional_1.OrUndefined(this.givenInitial)).find((i) => optional_1.isSome(this.coerce(i))) ||
                false);
        }
        fromStreamChunk(chunk, name = this.type) {
            return chunk.readBoolean();
        }
        toStreamChunk(val, chunk, name = this.type) {
            chunk.writeBoolean(val);
        }
    }
    Definition.type = 'Boolean';
    Definition.bytes = 1;
    return Definition;
})();
exports.Definition = Definition;
//# sourceMappingURL=boolean.js.map