import { Option } from '../optional';
import { Definition as Base, TypeName, ScalarTypeArg } from './base';
import { ChunkBuffer } from '../stream-buffer';
export declare type ValueType = number;
export declare type CharInitType = string | number;
export declare type CharScalarTypeArg = ScalarTypeArg<CharInitType>;
export declare class Definition extends Base<number> {
    static readonly type: TypeName;
    static readonly bytes: number;
    readonly type: TypeName;
    readonly bytes: number;
    readonly givenInitial: Option<number>;
    create(...vals: CharInitType[]): number;
    coerce(v: CharInitType | undefined): Option<number>;
    fromStreamChunk(chunk: ChunkBuffer, name?: string): number;
    toStreamChunk(val: number, chunk: ChunkBuffer, name?: string): void;
    constructor(arg?: CharScalarTypeArg);
}
export declare type Char = Definition;
