"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Definition = void 0;
const optional_1 = require("../optional");
const base_1 = require("./base");
let Definition = /** @class */ (() => {
    class Definition extends base_1.Definition {
        constructor(arg) {
            super();
            this.type = Definition.type;
            this.bytes = Definition.bytes;
            const val = (arg || {}).initial;
            this.givenInitial = this.coerce(val);
        }
        create(...vals) {
            const found = vals.concat(optional_1.OrUndefined(this.givenInitial)).find((val) => {
                const typ = typeof val;
                return typ === 'number' || typ === 'string';
            });
            if (typeof found === 'string') {
                return found.charCodeAt(0);
            }
            if (typeof found === 'number') {
                return ~~found;
            }
            return 0;
        }
        coerce(v) {
            if (typeof v === 'number') {
                return optional_1.SomeOption(v);
            }
            if (typeof v === 'string') {
                return optional_1.SomeOption(v.charCodeAt(0));
            }
            return optional_1.NoneOption;
        }
        fromStreamChunk(chunk, name = this.type) {
            return chunk.readUint8();
        }
        toStreamChunk(val, chunk, name = this.type) {
            chunk.writeUint8(val);
        }
    }
    Definition.type = 'Char';
    Definition.bytes = 1;
    return Definition;
})();
exports.Definition = Definition;
//# sourceMappingURL=char.js.map