import { Option } from '../optional';
import { Definition as Base, TypeName } from './base';
import { NestedPartial } from '../nested';
import { Funcs } from '../align';
import { ChunkBuffer } from '../stream-buffer';
export declare abstract class ArrayTypeAttribute<B> extends Base<B[]> {
    abstract readonly element: Base<B>;
    abstract readonly length: number;
}
export declare type ElementType<B> = B | NestedPartial<B>;
export interface FixedArrayArg<B, T extends Base<B> = Base<B>> {
    readonly element: T;
    readonly length: number;
    readonly initial?: ElementType<B>[];
    readonly alignFuncs?: Partial<Funcs<string>>;
}
export declare function create<B>(len: number, cb: (idx: number) => B): B[];
export declare class Definition<B, T extends Base<B> = Base<B>> extends ArrayTypeAttribute<B> {
    static readonly type: TypeName;
    readonly type: TypeName;
    readonly bytes: number;
    readonly length: number;
    readonly element: T;
    readonly alignFuncs: Funcs<string>;
    readonly givenInitial: Option<ElementType<B>[]>;
    constructor(el: FixedArrayArg<B, T>);
    create(...initials: ElementType<B>[][]): B[];
    coerce(vals: unknown[]): Option<ElementType<B>[]>;
    fromStreamChunk(nrb: ChunkBuffer, name?: string): B[];
    toStreamChunk(val: B[], nwb: ChunkBuffer, name?: string): void;
}
