import { Option } from '../optional';
import { Definition as Base, TypeName } from './base';
import { CharInitType, Definition as Char } from './char';
import { Funcs } from '../align';
import { ChunkBuffer } from '../stream-buffer';
export declare type FixedCStringInitType = string | CharInitType[];
export interface FixedCStringArg {
    readonly length: number;
    readonly initial?: FixedCStringInitType;
    readonly alignFuncs?: Funcs<string>;
}
export declare type ValueType = number[];
export declare class Definition extends Base<number[]> {
    static readonly type: TypeName;
    static readonly element: Char;
    readonly type: TypeName;
    readonly element: Char;
    readonly bytes: number;
    readonly length: number;
    readonly alignFuncs: Funcs<string>;
    readonly givenInitial: Option<FixedCStringInitType>;
    create(...initials: FixedCStringInitType[]): number[];
    coerce(m: FixedCStringInitType | undefined): Option<number[]>;
    constructor(iel: FixedCStringArg);
    fromStreamChunk(chunk: ChunkBuffer, name?: string): number[];
    toStreamChunk(val: number[], chunk: ChunkBuffer, name?: string): void;
}
export declare type FixedCString = Definition;
