import { Option } from '../optional';
import { Definition as Base, ScalarTypeArg } from './base';
import { Definition as Uint32 } from './uint32';
import { ChunkBuffer } from '../stream-buffer';
export interface MutableHighLow {
    high: number;
    low: number;
}
export declare type HighLow = Readonly<MutableHighLow>;
export declare abstract class HighLowType extends Base<HighLow> {
    static readonly uint32: Uint32;
    static readonly bytes: number;
    readonly givenInitial: Option<Partial<HighLow>>;
    readonly bytes: number;
    coerce(hl?: Partial<HighLow>): Option<Partial<HighLow>>;
    create(...args: Partial<HighLow>[]): HighLow;
    fromStreamChunk(chunk: ChunkBuffer, name?: string): HighLow;
    toStreamChunk(val: HighLow, chunk: ChunkBuffer, name?: string): void;
    constructor(ival?: ScalarTypeArg<Partial<HighLow>>);
}
