export * as Base from './base';
export * as Boolean from './boolean';
export * as Char from './char';
export * as Uint8 from './uint8';
export * as Uint16 from './uint16';
export * as Short from './short';
export * as Uint32 from './uint32';
export * as Int from './int';
export * as Float from './float';
export * as Double from './double';
export * as Long from './long';
export * as Uint64 from './uint64';
export * as FixedCString from './fixed-cstring';
export * as FixedArray from './fixed-array';
export * as BitStruct from './bit-struct';
export * as Struct from './struct';
import { Definition as Base } from './base';
import { Definition as Boolean } from './boolean';
import { Definition as Uint8 } from './uint8';
import { Definition as Uint16 } from './uint16';
import { Definition as Uint32 } from './uint32';
import { Definition as Char } from './char';
import { Definition as Short } from './short';
import { Definition as Int } from './int';
import { Definition as Double } from './double';
import { Definition as Float } from './float';
import { Definition as Uint64 } from './uint64';
import { Definition as Long } from './long';
import { Definition as FixedCString } from './fixed-cstring';
import { Definition as BitStruct } from './bit-struct';
export declare type JSScalarTypes = Boolean | Uint8 | Char | Uint16 | Short | Uint32 | Int | Float | Double;
export declare type ScalarTypes = JSScalarTypes | Uint64 | Long;
export declare const SimpleScalarTypesList: (typeof Boolean | typeof Char | typeof Long)[];
export declare const ScalarTypesList: (typeof Boolean | typeof Char | typeof Long | typeof FixedCString | typeof BitStruct)[];
export declare function isScalar<T>(def: Base<T>): boolean;
export declare function isBitStruct(def: Base<unknown>): def is BitStruct;
export declare function isFixedCString(def: Base<unknown>): def is FixedCString;
export declare function isHighLow(def: Base<unknown>): def is Long;
export declare function isFixedArray<T>(def: Base<T>): boolean;
export declare function isStruct<T>(def: Base<T>): boolean;
export declare enum AttributeType {
    Scalar = 0,
    FixedArray = 1,
    Struct = 2
}
export declare function toAttributeType<T>(def: Base<T>): AttributeType;
