"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberType = void 0;
const optional_1 = require("../optional");
const base_1 = require("./base");
class NumberType extends base_1.Definition {
    constructor(ival, fn) {
        super();
        const oval = (ival || {}).initial;
        this.coerce = (val) => typeof val === 'number' ? optional_1.SomeOption(fn(val)) : optional_1.NoneOption;
        this.givenInitial = this.coerce(oval);
    }
    create(...vals) {
        return vals.concat(optional_1.OrUndefined(this.givenInitial)).find((i) => optional_1.isSome(this.coerce(i))) || 0;
    }
}
exports.NumberType = NumberType;
//# sourceMappingURL=number-type.js.map