"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Definition = void 0;
const number_type_1 = require("./number-type");
let Definition = /** @class */ (() => {
    class Definition extends number_type_1.NumberType {
        constructor(arg = {}) {
            super(arg, (v) => (~~v & 0x7fff) | ((v >= 0 ? 0 : 1) << 15));
            this.type = Definition.type;
            this.bytes = Definition.bytes;
        }
        fromStreamChunk(chunk, name = this.type) {
            return chunk.readUint16();
        }
        toStreamChunk(val, chunk, name = this.type) {
            chunk.writeUint16(val);
        }
    }
    Definition.type = 'Short';
    Definition.bytes = 2;
    return Definition;
})();
exports.Definition = Definition;
//# sourceMappingURL=short.js.map