"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Definition = void 0;
const number_type_1 = require("./number-type");
let Definition = /** @class */ (() => {
    class Definition extends number_type_1.NumberType {
        constructor(arg = {}) {
            super(arg, (v) => ~~v & 0xffffffff);
            // public static readonly create: typeof numberCreate = numberCreate;
            this.type = Definition.type;
            this.bytes = Definition.bytes;
        }
        fromStreamChunk(chunk, name = this.type) {
            return chunk.readUint32();
        }
        toStreamChunk(val, chunk, name = this.type) {
            chunk.writeUint32(val);
        }
    }
    Definition.type = 'Uint32';
    Definition.bytes = 4;
    return Definition;
})();
exports.Definition = Definition;
//# sourceMappingURL=uint32.js.map