"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nestedAssign = void 0;
const optional_1 = require("./optional");
function nestedAssignObject(field, target, without) {
    let found = false;
    const out = without
        .map((i) => Object.entries(i))
        .reduce((r, entries) => {
        entries.forEach((entry) => {
            const key = entry[0];
            const ival = entry[1];
            let val = r[key];
            if (val === undefined) {
                val = [];
                r[key] = val;
            }
            if (eval !== undefined) {
                found = true;
                val.push(ival);
            }
        });
        return r;
    }, {});
    if (!found) {
        return optional_1.NoneOption;
    }
    let theTarget = target;
    if (field !== undefined) {
        const my = target;
        theTarget = my[field] = my[field] || {};
    }
    // console.log(out);
    Object.entries(out).reduce((r, [key, args]) => {
        nestedAssign(key, r, ...args);
        return r;
    }, theTarget);
    return optional_1.SomeOption(target);
}
function nestedAssignArray(field, target, without) {
    if (!without.length) {
        return optional_1.NoneOption;
    }
    let found = false;
    let theTarget = [];
    if (field !== undefined && typeof target === 'object') {
        const my = target;
        theTarget = my[field] = my[field] || theTarget;
    }
    else if (Array.isArray(target)) {
        theTarget = target;
    }
    const tmp = without.reverse().reduce((ret, arr) => {
        arr.forEach((item, idx) => {
            if (item === undefined) {
                return;
            }
            const o = nestedAssign(undefined, ret[idx] || {}, item);
            if (optional_1.isSome(o)) {
                ret[idx] = o.some;
                found = true;
            }
        });
        return ret;
    }, theTarget);
    return found ? optional_1.SomeOption(tmp) : optional_1.NoneOption;
}
function nestedAssign(field, target, ...os) {
    if (!os.length) {
        return optional_1.NoneOption;
    }
    const without = os.filter((i) => i !== undefined);
    const type = without.reduce((r, v) => {
        return r === (Array.isArray(v) ? 'array' : typeof v) ? r : 'notuniform';
    }, Array.isArray(without[0]) ? 'array' : typeof without[0]);
    if (type === 'notuniform') {
        throw Error('assignable Type has to be unified');
    }
    if (type === 'object') {
        return nestedAssignObject(field, target, without);
    }
    if (type === 'array') {
        return nestedAssignArray(field, target, without);
    }
    if (type === 'undefined') {
        return optional_1.NoneOption;
    }
    if (field !== undefined && typeof target === 'object') {
        const my = target;
        my[field] = without[0];
        return optional_1.SomeOption(target);
    }
    else {
        if (without[0] != undefined) {
            return optional_1.SomeOption(without[0]);
        }
        return optional_1.NoneOption;
    }
}
exports.nestedAssign = nestedAssign;
//# sourceMappingURL=utils.js.map