import { TSWriter, TSRefWriter, TSWriterArgs, TSWriteLine } from './ts';
import { Types } from '../definition';
export interface Import {
    readonly name: string;
    readonly as?: string;
}
export interface TSImportArgs {
    readonly external?: {
        readonly fname: string;
        readonly defs: Import[];
    };
    readonly sWriter?: TSRefWriter;
}
export declare class TSImport<T> {
    readonly imp: TSImportArgs;
    constructor(imp: TSImportArgs);
    get key(): string;
    toString(wr: TSWriter): string;
}
export declare class TSImports<T> {
    readonly args: TSWriterArgs;
    private readonly imports;
    constructor(args: TSWriterArgs);
    add(ts: TSImport<T>): TSImport<T>;
    values(): TSImport<T>[];
    prepend<T>(wl: TSWriteLine, def: Types.Base.NamedType<T>): void;
}
