import { Types } from '../definition';
export declare class TSWriteLine {
    wr: TSWriter;
    private readonly lines;
    constructor(wr: TSWriter);
    prependLine(i: number, line: string): void;
    prepend(i: number, line: string): void;
    writeLine(i: number, lines: string): void;
    write(i: number, lines: string): void;
    action(i: number, lines: string, appendNewLine: boolean, action: (s: string) => void): void;
    toString(): string;
}
export declare function writeCloneFunction(wl: TSWriteLine): void;
export declare function tsStringify<B>(iobj: unknown, typ: Types.Base.Definition<B>, wr: TSWriter): string;
export declare function typeDefinition<T>(t: Types.Base.Definition<T>, typeName: string, wrapStruct?: (s: string) => string): string;
export declare function attributeDefinition(def: Types.Struct.BaseAttribute): string;
export declare function initialValue<T>(_wr: TSWriter, vname: string, def: Types.Base.Definition<T>): string;
export interface TSRefWriter {
    readonly def: {
        name: string;
    };
    readonly fname: string;
    write(wr: TSWriter): TSWriteLine;
}
export interface TSImportArgs<T> {
    readonly external?: {
        readonly fname: string;
        readonly def: string;
    };
    readonly sWriter?: TSRefWriter;
}
export interface TSWriterArgs {
    readonly runtimePath: string;
    readonly definitionPath: string;
    readonly generationPath: string;
    readonly quote: string;
    readonly indent: string;
}
export interface Struct {
    readonly writer: TSRefWriter;
    written?: TSWriteLine;
}
export interface FixedArray {
    readonly writer: TSRefWriter;
    written?: TSWriteLine;
}
export declare class TSWriter {
    readonly structs: Map<string, Struct>;
    readonly fixedArrays: Map<string, FixedArray>;
    args: TSWriterArgs;
    constructor(args?: Partial<TSWriterArgs>);
    indent(level: number): string;
    quote(val: string): string;
    backQuote(val: string): string;
    structClass(def: Types.Struct.Definition, level: number): Struct;
    bitStructClass(def: Types.BitStruct.Definition, level: number): Struct;
    generator<T>(def: Types.Base.Definition<T>): TSWriter;
    getStructs(): Struct[];
}
export declare function TSGenerator<T>(def: Types.Base.Definition<T>, writer?: TSWriter): TSWriter;
